package com.example.dpanntout;

import android.content.Intent;
import android.database.Cursor;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.ListView;
import android.widget.SimpleCursorAdapter;
import android.widget.Toast;

import androidx.activity.EdgeToEdge;
import androidx.appcompat.app.AppCompatActivity;
import androidx.core.graphics.Insets;
import androidx.core.view.ViewCompat;
import androidx.core.view.WindowInsetsCompat;

import bdd.ClientDAO;
import bdd.InterventionDAO;
import metier.Client;

public class ListeClient extends AppCompatActivity {
    private int  idClientSelectionne = -1;
    private Client clientSelectionne;


    private ClientDAO clientDAO;  // Déclare cette variable en haut de la classe.

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        EdgeToEdge.enable(this);
        setContentView(R.layout.activity_liste_client);
        ViewCompat.setOnApplyWindowInsetsListener(findViewById(R.id.main), (v, insets) -> {
            Insets systemBars = insets.getInsets(WindowInsetsCompat.Type.systemBars());
            v.setPadding(systemBars.left, systemBars.top, systemBars.right, systemBars.bottom);
            return insets;
        });
        Initialisation();

    }
    private void Initialisation() {
        //gestion du bouton quitter
        Button btQuitterP2 = (Button) findViewById(R.id.btQuitterP2);
        //associer l'evenement quitter au boutton quitter
        btQuitterP2.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                finish();
            }
        });
        //gestion du bouton modifier un client
        Button btModifP2 = (Button)findViewById(R.id.btModifP2);
        btModifP2.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if (verifierClientSelectionne()) {
                   demarrerPageModification();
                }
            }
        });

       afficherLesClients();
    }

    private void demarrerPageModification () {
        Intent intent = new Intent(ListeClient.this, ModifierLeClient.class);
        intent.putExtra("nom", clientSelectionne.getNom());
        intent.putExtra("prenom", clientSelectionne.getPrenom());
        intent.putExtra("mail", clientSelectionne.getAdrMail());
        intent.putExtra("numero", clientSelectionne.getNumTel());
        intent.putExtra("adresse", clientSelectionne.getAdrPostale());
        startActivity(intent);

    }

    public void afficherLesClients() {
        Log.d("bdd", "debut afficherLesInterventions");
        clientDAO = new ClientDAO(this);
        Cursor c = clientDAO.readLesClients();
        Log.d("Database", "Nombre de client(s) : " + c.getCount());
        Toast.makeText(getApplicationContext(), "il y a  " + c.getCount() + " clients ", Toast.LENGTH_SHORT).show();
        clientDAO.close();
        //nom des 4 attributs lus dans la bdd
        String[] from = new String[]{"nom", "prenom", "adrMail", "numTel", "adrPostale"};
        //reference des controles graphiques qui afficheront les valeurs
        int[] to = new int[]{R.id.tvNomP2_2, R.id.tvPrenomP2_2, R.id.tvMelP2_2, R.id.tvNumP2_2, R.id.tvAdP2_2};
        //adapter : lien entre les données et les controless graphiques
        SimpleCursorAdapter dataAdapter = new SimpleCursorAdapter(this, R.layout.ligne_client, c, from, to, 0);
        ListView lvCli = (ListView) findViewById(R.id.lvCli);
        lvCli.setAdapter(dataAdapter);


        configurerSelectionClient();
    }

//methode pour selectionner un client dans la liste et basculer page modif avec ses do
    private void configurerSelectionClient() {
        ListView lvCli = findViewById(R.id.lvCli);
        lvCli.setOnItemClickListener((parent, view, position, id) -> {
            // Récupération du curseur correspondant à l'élément sélectionné
            Cursor c = (Cursor) parent.getItemAtPosition(position);

            // On récupère les indices des colonnes
            int indexNom = c.getColumnIndexOrThrow("nom");
            int indexPrenom = c.getColumnIndexOrThrow("prenom");
            int indexMail = c.getColumnIndexOrThrow("adrMail");
            int indexNumTel = c.getColumnIndexOrThrow("numTel");
            int indexAdresse = c.getColumnIndexOrThrow("adrPostale");

            // On récupère les valeurs des colonnes
            String nomClient = c.getString(indexNom);
            String prenomClient = c.getString(indexPrenom);
            String mailClient = c.getString(indexMail);
            String numTelClient = c.getString(indexNumTel);
            String adresseClient = c.getString(indexAdresse);

            // On affiche ces infos pour le débogage
            Toast.makeText(getApplicationContext(), "Client sélectionné : " + nomClient + " " + prenomClient, Toast.LENGTH_SHORT).show();

            // Passage de toutes les données à la page de modification
            Intent intent = new Intent(ListeClient.this, ModifierLeClient.class);
            intent.putExtra("idClient", (int) id); // Passer l'ID du client
            intent.putExtra("nom", nomClient);
            intent.putExtra("prenom", prenomClient);
            intent.putExtra("mail", mailClient);
            intent.putExtra("numTel", numTelClient);
            intent.putExtra("adresse", adresseClient);
            startActivity(intent);
        });
    }



    private boolean verifierClientSelectionne() {
        if (idClientSelectionne == -1) {
            Toast.makeText(this, "Sélectionnez d'abord un client à modifier ", Toast.LENGTH_SHORT).show();
            return false;
        }
        return true;
    }


























































}