package com.example.dpanntout;

import android.content.Intent;
import android.database.Cursor;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.ListView;
import android.widget.SimpleCursorAdapter;
import android.widget.Toast;

import androidx.activity.EdgeToEdge;
import androidx.appcompat.app.AppCompatActivity;
import androidx.core.graphics.Insets;
import androidx.core.view.ViewCompat;
import androidx.core.view.WindowInsetsCompat;

import bdd.ClientDAO;
import bdd.InterventionDAO;

public class ListeIntervention extends AppCompatActivity {

    private InterventionDAO interventionDAO;  // Déclare cette variable en haut de la classe.

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        EdgeToEdge.enable(this);
        setContentView(R.layout.activity_liste_intervention);
        ViewCompat.setOnApplyWindowInsetsListener(findViewById(R.id.main), (v, insets) -> {
            Insets systemBars = insets.getInsets(WindowInsetsCompat.Type.systemBars());
            v.setPadding(systemBars.left, systemBars.top, systemBars.right, systemBars.bottom);
            return insets;
        });
        Initialisation();
    }

    private void Initialisation() {
        //gestion du bouton quitter
        Button tvBtQuitP3 = (Button) findViewById(R.id.tvBtQuitP3);
        //associer l'evenement quitter au boutton quitter
        tvBtQuitP3.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                finish();
            }
        });
        afficherLesInterventions();
    }


    public void afficherLesInterventions(){
        Log.d("bdd", "debut afficherLesInterventions");
        interventionDAO  = new InterventionDAO(this );
        Cursor c = interventionDAO.readLesInterventions();
        Log.d("Database", "Nombre d'interventions(s) : " + c.getCount());
        Toast.makeText(getApplicationContext(), "il y a  " + c.getCount() + " interventions ", Toast.LENGTH_SHORT).show();
        interventionDAO.close();
        //nom des 4 attributs lus dans la bdd
        String[] from = new String[]{"idCli", "dateTime", "observation"};
        //reference des controles graphiques qui afficheront les valeurs de la page ligne_intervention
        int [] to = new int[] {R.id.tvIdCliInter3_3 , R.id.tvDateInter3_3, R.id.tvobsInter3_3 };
        //adapter : lien entre les données et les controless graphiques
        SimpleCursorAdapter dataAdapter = new SimpleCursorAdapter(this , R.layout.ligne_intervention, c, from,to,0);
        ListView lvInter = (ListView) findViewById(R.id.lvInter);
        lvInter.setAdapter(dataAdapter);
    }



}